package binomialheap;

/**
 * The Data class provides data items for insertion into a BinomialHeap.
 * These data items have an identifier and a priority.
 *
 * The data items are for testing only.
 * A useful BinomialHeap class would have a type parameter for the type of data
 * items that could be added or removed.
 */
public class Data
        implements Comparable<Data> {

  private String identifier;
  private int priority;

  /**
   * new Data(string
   * @param string
   * @param priority
   */
  public Data(String string, int priority) {
    this.identifier = string;
    this.priority = priority;
  }

  /**
   * data.getIdentifier() returns the identifier for data.
   * @return the identifier
   */
  public String getIdentifier() {
    return identifier;
  }

  /**
   * data.getPriority() returns the priority for data.
   * @return the priority
   */
  public int getPriority() {
    return priority;
  }

  /**
   * data.compareTo(otherData) returns a priority comparison between data and
   * otherData.
   * This priority comparison is positive if the data has higher priority than
   * otherData, 0 if they have the same priority, or negative if the data has
   * lower priority than otherData.
   * For this comparison, lower priority values have higher priority.
   * @param otherData
   * @return a priority comparison
   */
  public int compareTo(Data otherData) {
    return otherData.priority - priority;
  }

  @Override
  public String toString() {
    return "Data(\"" + identifier + ", " + priority + ")";
  }

}
